//==================================================================================================
// CONCEPTS FOR TEMPLATE SPECIALIZATION IN C++                            c4ts++_plain/gnx_list.hpp
//                                                      By Bruno Bachelet, Antoine Mahul & Loic Yon
//==================================================================================================
// Copyright (c) 2010-2016
// Bruno Bachelet - bruno@nawouak.net - http://www.nawouak.net
// Antoine Mahul  - antoine.mahul@clermont-universite.fr
// Loic Yon       - loic.yon@isima.fr - http://www.isima.fr/~loic
//
// This file is part of the C4TS++ library. This library is free software; you can redistribute it
// and/or modify it under the terms of the GNU Library General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
// the GNU Library General Public License for more details (http://www.gnu.org).
//
// This file provides metaprogramming elements to manipulate typelists.

// Guardian //--------------------------------------------------------------------------------------
#ifndef _C4TS_GNX_LIST_
#define _C4TS_GNX_LIST_

// Headers //---------------------------------------------------------------------------------------
#include <gnx_basic.hpp>

//------------------------------------------------------------------------------------------gnx_list
/* Represents a linked list of types, called a "typelist". */
template <class CONTENT,class NEXT> struct gnx_list {
 typedef CONTENT content;
 typedef NEXT    next;
};

//-----------------------------------------------------------------------------------gnx_search_list
/* Returns whether a type is stored inside a typelist. */
template <class ELEMENT,class LIST> struct gnx_search_list
: gnx_or< gnx_same<ELEMENT,typename LIST::content>,
          gnx_search_list<ELEMENT,typename LIST::next>
        > {};

template <class ELEMENT> struct gnx_search_list<ELEMENT,gnx_nil> : gnx_false {};

// End //-------------------------------------------------------------------------------------------
#endif
